Description

There is no easy way how to define and manage template producing valid CSV output.

Tasks that needs to be easier:

- visually match header and values

- reorder columns

- comment out column

- copy & paste column def from other reports

- generate properly quoted and valid CSV

Related issues:

Related to Foreman - Feature #10521: As a user i like to have an advanced rep... Closed

Associated revisions

Revision 63fbccbf - 10/03/2018 09:13 AM - Martin Bacovsky

Fixes #25099 - Add macros for easier report definition

Add rows to a report with

<%- report_row(

'Column header 1': 'Value 1',

'Column header 2': `Value 2`,

) ->

and render the report with

<= report_render -%>

Each row of the report needs to have the same columns.

report_render produces properly quoted valid CSV.

Values are converted to a String using to_s.

Enumerable values are comma separated and serialized.

Experimental render to YAML is included (report_render(format: :yaml)

Enumerable values are kept structured in this format.

History

#1 - 10/02/2018 08:38 AM - The Foreman Bot

- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/6100 added

#2 - 10/02/2018 08:41 AM - Martin Bacovsky

- Related to Feature #10521: As a user i like to have an advanced reporting system with fully customizable reports added

#3 - 10/03/2018 09:14 AM - Marek Hulán

- Fixed in Releases 1.20.0 added
#4 - 10/03/2018 10:01 AM - Martin Bacovsky

- Status changed from Ready For Testing to Closed

Applied in changeset 63fbccbf889224b4d5cc9cda9cb397eb5d9a5188.
